Unit Unit1;

{$MODE ObjFPC}{$H+}

Interface

Uses
  LCLIntf, LCLType, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, math, IntfGraphics, Menus, fpImage;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Edit3: TEdit;
    Edit4: TEdit;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    MenuItem1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Image2: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Image3: TImage;
    Label2: TLabel;
    Edit2: TEdit;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    Procedure Button1Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure MenuItem1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  End;

  Tarr = Array Of Array Of Integer;

  TSubLine = Record
    Angle: Integer;
    Radius: Integer;
    //    dummy: Integer;
  End;

  TLineArr = Array Of TSubLine;

Var
  Form1: TForm1;
  indata: TBitmap;

Implementation

{$R *.lfm}

Procedure ClearLines2(Var Lines: TLineArr; ToleranceAngle, ToleranzeRadius: Integer);
{Var
  c, j, i: Integer;
  tmp: TLineArr;}
Var
  b: Tbitmap;
  i: Integer;
Begin
  Raise Exception.create('Das visualisiert das Problem..');
  b := TBitmap.create;
  b.Width := 256;
  b.height := 256;
  b.canvas.brush.color := clblack;
  b.Canvas.Rectangle(-1, -1, 257, 257);
  For i := 0 To High(lines) Do
    b.Canvas.Pixels[lines[i].Angle, lines[i].Radius] := clwhite;
  b.SaveTofile('out.bmp');
  b.free;
  {  setlength(tmp, high(lines) + 1);
    For i := 0 To high(lines) Do Begin
      c := 0;
      // Alle
      For j := 0 To High(Lines) Do Begin
        If (abs(lines[j].Radius - lines[i].Radius) < 2 * ToleranzeRadius) And
          (abs(lines[j].Angle - lines[i].Angle) < 2 * ToleranceAngle) Then Begin
          tmp[c] := lines[i];
          inc(c);
        End;
      End;

    End;
    }
End;

Procedure ClearLines(Var Lines: TLineArr; ToleranceAngle, ToleranzeRadius: Integer);
Var
  i, j: Integer;
  t: TSubline;
  tmp: TLineArr;
Begin
  //  If (ToleranceAngle <= 0) And (ToleranzeRadius <= 0) Then exit;

  setlength(tmp, 0);
  i := 0;
  While i <= high(Lines) Do Begin
    j := i + 1;
    While (j <= high(lines)) And (abs(lines[j].Radius - lines[i].Radius) < 2 * ToleranzeRadius) And
      (abs(lines[j].Angle - lines[i].Angle) < 2 * ToleranceAngle)
      Do
      inc(j);
    setlength(tmp, high(tmp) + 2);
    tmp[high(tmp)] := lines[(i + j) Div 2];
    //    If j <> i Then
    i := j - 1;
    inc(i);
  End;

  // Sortieren nach den Radien
  For i := high(tmp) Downto 1 Do Begin
    For j := 1 To i Do Begin
      If tmp[j].Radius < tmp[j - 1].Radius Then Begin
        t := tmp[j - 1];
        tmp[j - 1] := tmp[j];
        tmp[j] := t;
      End;
    End;
  End;
  // Nach der Toleranz selektieren ..
  setlength(Lines, 0);
  i := 0;
  While i <= high(tmp) Do Begin
    j := i + 1;
    While (j <= high(tmp)) And (abs(tmp[j].Radius - tmp[i].Radius) < 2 * ToleranzeRadius) And
      (j <= high(tmp)) And (abs(tmp[j].Angle - tmp[i].Angle) < 2 * ToleranceAngle)
      Do
      inc(j);
    setlength(Lines, high(Lines) + 2);
    Lines[high(Lines)] := tmp[(i + j) Div 2];
    //    If j <> i Then
    i := j - 1;
    inc(i);
  End;
  //  setlength(lines, 0);
  //  lines := tmp;
End;

Procedure Setpixel(Const Bitmap: Tbitmap; x, y, Value, Scale: Integer);
Var
  v: Integer;
  c: TColor;
Begin
  v := min(255, max(0, Value * Scale));
  c := v + v Shl 8 + v Shl 16;
  Bitmap.canvas.pixels[x, y] := c;
End;

Function GetPixel(Const Bitmap: TLazIntfImage; x, y: Integer): Byte;
Var
  c: TFPColor;
Begin
  // Wir Rechnen nur in Grau
  // Result := max(0,min(255,round( c.red * Bla Bla
  c := bitmap.Colors[x, y];
  Result := byte(c.red Shr 8); // So gehts auch
End;

(*
Addiert das Akkum Array
*)

Procedure Insert(x, y: Integer; Var Data: TArr);
Var
  da, i: Integer;
  s, c: Extended;
  d, a: Single;
  maxh: Integer;
Begin
  maxh := high(Data[0]);
  // ber Alle Winkel
  For i := 0 To high(Data) Do Begin
    a := degtorad(i);
    SinCos(a, s, c);
    d := x * c + y * s;
    da := min(maxh + 1, max(-1, round(d)));
    If Not ((da > Maxh) Or (da < 0)) Then
      Data[i, da] := Data[i, da] + 1;
  End;
End;

Procedure Hough(Const Bitmap: Tbitmap; Var Data: TArr);
Var
  i, j: Integer;
  v: Byte;
  TempIntfImg: TLazIntfImage;
Begin
  Bitmap.pixelformat := pf24bit;
  TempIntfImg := TLazIntfImage.Create(0, 0);
  TempIntfImg.LoadFromBitmap(Bitmap.Handle, Bitmap.MaskHandle);
  For i := 0 To Bitmap.width - 1 Do
    For j := 0 To Bitmap.height - 1 Do Begin
      v := Getpixel(TempIntfImg, i, j);
      // Wir sind an einem Interessanten Punkt
      If v <> 0 Then Begin
        Insert(i, j, Data);
      End;
    End;
  TempIntfImg.free;
End;

Procedure Reset(Var Array_: Tarr);
Var
  i, j: Integer;
Begin
  For i := low(Array_) To High(Array_) Do
    For j := low(Array_[i]) To High(Array_[i]) Do
      Array_[i, j] := 0;
End;

Function getmaximum(Var Array_: Tarr): integer;
Var
  max_, i, j: Integer;
Begin
  max_ := 0;
  For i := low(Array_) To High(Array_) Do
    For j := low(Array_[i]) To High(Array_[i]) Do
      max_ := max(max_, Array_[i, j]);
  result := max_;
End;

Procedure DrawLine(Const Bitmap: Tbitmap; Angle, Radius: Integer);
Var
  s, c: Extended;
  dx, dy: Integer;
  m: TPoint;
  ma: Integer;
Begin
  sincos(degtorad(angle), s, c);
  m := Point(round(c * Radius), round(s * radius));
  sincos(degtorad(angle + 90), s, c);
  ma := max(bitmap.width, bitmap.height);
  dx := round(c * ma);
  dy := round(s * ma);
  With bitmap.canvas Do Begin
    moveto(m.x + dx, m.y + dy);
    lineto(m.x - dx, m.y - dy);
  End;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  If opendialog1.execute Then Begin
    indata.loadfromfile(opendialog1.FileName);
    image1.Picture.assign(indata);
    image2.left := image1.left + image1.width + 10;
    Image3.top := image1.top + image1.height + 10;
  End;
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Begin
  indata.free;
End;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  opendialog1.initialdir := extractfilepath(paramstr(0));
  Caption := 'Allgemeine Hough-Transformation by Corpsman, Support : www.Corpsman.de';
  DecimalSeparator := ',';
  indata := Tbitmap.create;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Var
  a: Tarr;
  bm2, bm: Tbitmap;
  maximum, scale, i, j, t: Integer;
  mscale: Single;
  findboarders: Boolean;
  Lines: TLineArr;
Begin
  // Zwischenvariablen
  findboarders := Checkbox2.checked;
  bm := Tbitmap.create;
  bm2 := Tbitmap.create;
  bm.PixelFormat := pf24bit;
  bm.Assign(indata);
  scale := strtointdef(Edit1.text, 1);
  Mscale := strtofloat(Edit2.text);
  (*
  180 - Grad, mehr wre unntig ;)
        Maximale Amplitude
  *)
  setlength(a, 180, max(bm.width, bm.height)); // Initialisieren
  Reset(a); // Zrcksetzen
  // Berechen das Akkum Array's
  Hough(bm, a);
  // Anzeigen des Akkum Array's
  bm.width := high(a) + 1;
  bm.height := high(a[0]) + 1;
  For i := 0 To high(a) Do
    For j := 0 To High(a[i]) Do
      Setpixel(bm, i, j, a[i, j], scale);
  // Ausgabe des Akkum Array's
  image2.picture.assign(bm);
  // Auswerten des Akkum Array's
  Listbox1.items.clear;
  maximum := getmaximum(a);
  If checkbox1.checked Then Begin
    bm2.assign(image1.picture);
    bm2.canvas.pen.color := clBlue;
  End
  Else Begin
    bm2.width := image1.picture.width;
    bm2.height := image1.picture.height;
    With bm2.canvas Do Begin
      brush.color := clblack;
      rectangle(-1, -1, bm2.width + 1, bm2.height + 1);
      pen.color := clwhite;
    End;
  End;
  bm2.PixelFormat := pf24bit;
  t := round(Mscale * Maximum);
  setlength(Lines, 0);
  If t <> 0 Then Begin
    For i := 0 To high(a) Do
      For j := 0 To High(a[i]) Do
        If a[i, j] >= t Then Begin
          If findboarders Then Begin
            setlength(Lines, high(lines) + 2);
            lines[high(lines)].Angle := i;
            lines[high(lines)].Radius := j;
          End
          Else Begin
            Listbox1.items.add('Angle:' + inttostr(i) + ' Radius:' + inttostr(j));
            DrawLine(bm2, i, j);
          End;
        End;
  End;
  // Wenn nach Einzellinensegmenten gesucht werden soll.
  If findboarders Then Begin
    //{
    Das Erkennen von Kanten = Strecken ist noch nicht implementiert ..

    Als erstes sollten "hnliche" geraden zusammengefasst werden.
      Also wenn Angle und Radius nur sehr "wenig" abweichen.Sollte die
      Gemittelte Gerade gewhlt werden.

    Dann finden der Ecken dieser Geraden !!
      //}
    ClearLines(Lines, strtoint(edit3.text), strtoint(edit4.text));
    For i := 0 To High(lines) Do Begin
      Listbox1.items.add('Angle:' + inttostr(Lines[i].Angle) + ' Radius:' + inttostr(Lines[i].Radius));
      DrawLine(bm2, Lines[i].Angle, Lines[i].Radius);
    End;
    setlength(lines, 0);
  End;
  image3.Picture.Assign(bm2);
  // Freigeben
  setlength(a, 0, 0);
  bm.free;
  bm2.free;
End;

Procedure TForm1.MenuItem1Click(Sender: TObject);
Var
  f: Textfile;
  s: String;
  i: Integer;
Begin
  If SaveDialog1.execute Then Begin
    AssignFile(f, SaveDialog1.FileName);
    rewrite(f);
    For i := 0 To ListBox1.items.count - 1 Do Begin
      s := ListBox1.items[i];
      writeln(f, s);
    End;
    closefile(f);
  End;
End;

End.

